import * as i0 from '@angular/core';
import { PLATFORM_ID, Injectable, Inject, Component, Input, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { isPlatformBrowser } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';

class AngularCircularProgressbarService {
    constructor(platformId) {
        this.platformId = platformId;
    }
    get isBrowser() {
        return isPlatformBrowser(this.platformId);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarService, deps: [{ token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: Object, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }]; } });

class AngularCircularProgressbarComponent {
    constructor(platform) {
        this.platform = platform;
        this.percentage = 0;
        this.radius = 0;
        this.fontSize = 0;
        this.fontWeight = 400;
    }
    ngOnInit() {
        if (this.responsive && this.platform.isBrowser) {
            if (window.innerWidth > 1600) {
                this.width = this.width * 0.8;
                this.radius = this.radius * 0.8;
                this.fontSize = this.fontSize * 0.8;
                this.bgStrokeWidth = this.bgStrokeWidth * 0.8;
                this.progressStrokeWidth = this.progressStrokeWidth * 0.8;
                this.handleRadius = this.handleRadius * 0.8;
                this.mutedFontSize = this.mutedFontSize * 0.8;
            }
        }
        const circle = document.querySelector('circle.progress');
        const circleBg = document.querySelector('.circle-background');
        const svg = document.querySelector('.progress-circle');
        const width = this.width ? this.width : this.radius * 2.3;
        const clockWise = this.clockWise;
        const reversedText = this.reversedText;
        svg.style.width = width;
        svg.style.height = width;
        circle.r.baseVal.value = this.radius;
        circleBg.r.baseVal.value = this.radius;
        let radius = circle.r.baseVal.value;
        let circumference = radius * 2 * Math.PI;
        let originX = width / 2;
        let originY = width / 2;
        const percentText = document.querySelector('text.percent');
        const handle = document.querySelector('circle.handle');
        circle.style.strokeDasharray = `${circumference} ${circumference}`;
        circle.style.strokeDashoffset = `${circumference}`;
        function setProgress(percent) {
            if (reversedText) {
                percentText.innerHTML = percent + '%';
            }
            else {
                percentText.innerHTML = '%' + percent;
            }
            let reverse_percent = 100 - percent;
            let offset = (reverse_percent / 100) * circumference;
            if (clockWise) {
                circle.style.strokeDashoffset = 1 * offset;
            }
            else {
                circle.style.strokeDashoffset = -1 * offset;
            }
            // circle.style.cx = width - originX;
            setHandleRotation(percent);
        }
        // Position the handle at the end of the stroke
        function setHandleRotation(percent) {
            let angle = (180 + percent * 3.6) % 360;
            // Convert degrees to radians
            let angle_radians = (angle * Math.PI) / 180;
            let xOffset = radius * Math.sin(angle_radians);
            let yOffset = radius * Math.cos(angle_radians);
            let x;
            if (clockWise) {
                x = originX + -xOffset;
            }
            else {
                x = originX + xOffset;
            }
            let y = originY + yOffset;
            handle.attributes.cx.value = x;
            handle.attributes.cy.value = y;
        }
        setProgress(this.percentage);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarComponent, deps: [{ token: AngularCircularProgressbarService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.0", type: AngularCircularProgressbarComponent, selector: "angular-circular-progressbar", inputs: { percentage: "percentage", radius: "radius", width: "width", fontSize: "fontSize", fontFamily: "fontFamily", fontWeight: "fontWeight", textColor: "textColor", bgStrokeColor: "bgStrokeColor", bgStrokeWidth: "bgStrokeWidth", bgStrokeFill: "bgStrokeFill", progressStrokeColor: "progressStrokeColor", progressStrokeWidth: "progressStrokeWidth", progressStrokeFill: "progressStrokeFill", handleRadius: "handleRadius", handleBorderWidth: "handleBorderWidth", handleBorderColor: "handleBorderColor", handleFillColor: "handleFillColor", strokeLinecap: "strokeLinecap", clockWise: "clockWise", reversedText: "reversedText", defaultShadow: "defaultShadow", filterValue: "filterValue", mutedText: "mutedText", mutedFontSize: "mutedFontSize", mutedFontFamily: "mutedFontFamily", mutedFontWeight: "mutedFontWeight", mutedTextColor: "mutedTextColor", responsive: "responsive" }, ngImport: i0, template: `
    <svg class="progress-circle" width="500" height="500">
      <circle
        class="circle-background"
        [attr.stroke]="bgStrokeColor"
        [attr.stroke-width]="bgStrokeWidth"
        [attr.fill]="bgStrokeFill"
        [attr.r]="radius"
        cx="50%"
        cy="50%"
      />

      <circle
        class="progress"
        [attr.stroke]="progressStrokeColor"
        [attr.stroke-width]="progressStrokeWidth"
        [attr.fill]="progressStrokeFill"
        [attr.r]="radius"
        cx="50%"
        cy="50%"
        [attr.stroke-linecap]="strokeLinecap"
      />

      <circle
        class="handle"
        [attr.stroke]="handleBorderColor"
        [attr.stroke-width]="handleBorderWidth"
        [attr.fill]="handleFillColor"
        [attr.r]="handleRadius"
        cx="50%"
        cy="50%"
        [ngClass]="{ 'handle-shadow': defaultShadow }"
        [ngStyle]="{
          filter: filterValue
        }"
      />

      <text
        x="50%"
        y="50%"
        class="percent"
        [attr.font-size]="fontSize"
        [attr.font-family]="fontFamily"
        [attr.font-weight]="fontWeight"
        [attr.fill]="textColor"
        dominant-baseline="middle"
        text-anchor="middle"
      >
        50 %
      </text>
      <text
        *ngIf="mutedText"
        x="50%"
        y="70%"
        [attr.font-size]="mutedFontSize"
        [attr.font-family]="mutedFontFamily"
        [attr.font-weight]="mutedFontWeight"
        [attr.fill]="mutedTextColor"
        dominant-baseline="middle"
        text-anchor="middle"
      >
        {{ mutedText }}
      </text>
    </svg>
  `, isInline: true, styles: ["circle.progress{transform:rotate(-90deg);transform-origin:50% 50%}svg{display:block;margin:auto}.handle-shadow{filter:drop-shadow(-1px 4px 2px rgba(0,0,0,.25))}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'angular-circular-progressbar', template: `
    <svg class="progress-circle" width="500" height="500">
      <circle
        class="circle-background"
        [attr.stroke]="bgStrokeColor"
        [attr.stroke-width]="bgStrokeWidth"
        [attr.fill]="bgStrokeFill"
        [attr.r]="radius"
        cx="50%"
        cy="50%"
      />

      <circle
        class="progress"
        [attr.stroke]="progressStrokeColor"
        [attr.stroke-width]="progressStrokeWidth"
        [attr.fill]="progressStrokeFill"
        [attr.r]="radius"
        cx="50%"
        cy="50%"
        [attr.stroke-linecap]="strokeLinecap"
      />

      <circle
        class="handle"
        [attr.stroke]="handleBorderColor"
        [attr.stroke-width]="handleBorderWidth"
        [attr.fill]="handleFillColor"
        [attr.r]="handleRadius"
        cx="50%"
        cy="50%"
        [ngClass]="{ 'handle-shadow': defaultShadow }"
        [ngStyle]="{
          filter: filterValue
        }"
      />

      <text
        x="50%"
        y="50%"
        class="percent"
        [attr.font-size]="fontSize"
        [attr.font-family]="fontFamily"
        [attr.font-weight]="fontWeight"
        [attr.fill]="textColor"
        dominant-baseline="middle"
        text-anchor="middle"
      >
        50 %
      </text>
      <text
        *ngIf="mutedText"
        x="50%"
        y="70%"
        [attr.font-size]="mutedFontSize"
        [attr.font-family]="mutedFontFamily"
        [attr.font-weight]="mutedFontWeight"
        [attr.fill]="mutedTextColor"
        dominant-baseline="middle"
        text-anchor="middle"
      >
        {{ mutedText }}
      </text>
    </svg>
  `, styles: ["circle.progress{transform:rotate(-90deg);transform-origin:50% 50%}svg{display:block;margin:auto}.handle-shadow{filter:drop-shadow(-1px 4px 2px rgba(0,0,0,.25))}\n"] }]
        }], ctorParameters: function () { return [{ type: AngularCircularProgressbarService }]; }, propDecorators: { percentage: [{
                type: Input
            }], radius: [{
                type: Input
            }], width: [{
                type: Input
            }], fontSize: [{
                type: Input
            }], fontFamily: [{
                type: Input
            }], fontWeight: [{
                type: Input
            }], textColor: [{
                type: Input
            }], bgStrokeColor: [{
                type: Input
            }], bgStrokeWidth: [{
                type: Input
            }], bgStrokeFill: [{
                type: Input
            }], progressStrokeColor: [{
                type: Input
            }], progressStrokeWidth: [{
                type: Input
            }], progressStrokeFill: [{
                type: Input
            }], handleRadius: [{
                type: Input
            }], handleBorderWidth: [{
                type: Input
            }], handleBorderColor: [{
                type: Input
            }], handleFillColor: [{
                type: Input
            }], strokeLinecap: [{
                type: Input
            }], clockWise: [{
                type: Input
            }], reversedText: [{
                type: Input
            }], defaultShadow: [{
                type: Input
            }], filterValue: [{
                type: Input
            }], mutedText: [{
                type: Input
            }], mutedFontSize: [{
                type: Input
            }], mutedFontFamily: [{
                type: Input
            }], mutedFontWeight: [{
                type: Input
            }], mutedTextColor: [{
                type: Input
            }], responsive: [{
                type: Input
            }] } });

class AngularCircularProgressbarModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarModule, declarations: [AngularCircularProgressbarComponent], imports: [BrowserModule], exports: [AngularCircularProgressbarComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarModule, imports: [BrowserModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: AngularCircularProgressbarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AngularCircularProgressbarComponent],
                    imports: [BrowserModule],
                    exports: [AngularCircularProgressbarComponent],
                }]
        }] });

/*
 * Public API Surface of angular-circular-progressbar
 */
// export * from './lib/angular-circular-progressbar.service';

/**
 * Generated bundle index. Do not edit.
 */

export { AngularCircularProgressbarComponent, AngularCircularProgressbarModule };
//# sourceMappingURL=angular-circular-progressbar-with-handler.mjs.map
